SET QUOTED_IDENTIFIER OFF
SET NOCOUNT ON
GO

BEGIN
	DECLARE @AggregateNameCursorFlag 	INTEGER
	SET 		@AggregateNameCursorFlag 	= 0
	
	DECLARE	@errorCode	INTEGER
	SET 		@errorCode	= 0
	
	DECLARE	@AggregateName		nvarchar(256)
		
	DECLARE	AggregateNameListCursor CURSOR STATIC FOR
	SELECT DISTINCT name
	FROM sysobjects 
	WHERE	xtype IN ('AF')
		AND OBJECTPROPERTY(id, N'IsInlineFunction') = 0
		AND name NOT LIKE '%_CUSTOMOBJ'
		
	SET	@errorCode	=	@@ERROR
	IF	@errorCode != 0 GOTO CX_EXIT
		
	SET		@AggregateNameCursorFlag = 1
	OPEN	AggregateNameListCursor

	SET	@errorCode	=	@@ERROR
	IF	@errorCode != 0 GOTO CX_EXIT

	FETCH	NEXT 
	FROM AggregateNameListCursor
	INTO @AggregateName

	SET	@errorCode	=	@@ERROR
	IF	@errorCode != 0 GOTO CX_EXIT
	
	--Drop all functions
	WHILE	@@FETCH_STATUS = 0
	BEGIN
		print '>>> Drop Aggregate: ' + @AggregateName + ' <<<'
					
		IF EXISTS (select * from sysobjects where name = @AggregateName and OBJECTPROPERTY(id, N'IsInlineFunction') = 0)
			EXEC ('DROP AGGREGATE [' + @AggregateName + ']')

		SET	@errorCode	=	@@ERROR
		IF	@errorCode != 0 GOTO CX_EXIT

		FETCH	NEXT 
		FROM AggregateNameListCursor
		INTO @AggregateName

		SET	@errorCode	=	@@ERROR
		IF	@errorCode != 0 GOTO CX_EXIT		
	END

CX_EXIT:	
	IF @AggregateNameCursorFlag = 1
	BEGIN
			CLOSE				AggregateNameListCursor
			DEALLOCATE	AggregateNameListCursor
	END
END	

RETURN
GO
