SET QUOTED_IDENTIFIER OFF


--  ------------  Generated from [../../../Source/CommServer/DM2Db/CSView/DMResultSetStatistics.view] ---------- 

SET QUOTED_IDENTIFIER  OFF
SET ANSI_NULLS  ON
print "... Creating View: DMResultSetStatistics"
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[DMResultSetStatistics]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[DMResultSetStatistics]
GO

delete from GXDBVersions where name = 'DMResultSetStatistics' and type=4
insert into GXDBVersions  (type, name, revision, aliasname, SafeRevision) VALUES (4,'DMResultSetStatistics', '1.4', 'DMResultSetStatistics', '')
GO
SET QUOTED_IDENTIFIER  ON
GO
CREATE VIEW DMResultSetStatistics WITH SCHEMABINDING
AS
	select	CI.ContainerID as ContainerID,
			RS.AppType as AppType,
			count_big(*) as TotalCount,
			sum(RS.FileSizeKB) as TotalSizeKB,
			sum(case when RS.RestoreStatus = 4 then RS.FileSizeKB else 0 end) as DiskSpaceUsedKB
	from dbo.DMResultSet RS, dbo.DMContainerItem CI
	where RS.ResultSetID = CI.ResultSetID
	and (CI.Attribute & 4) = 0
	group by CI.ContainerID, RS.AppType
GO
IF EXISTS (SELECT * FROM sysindexes WHERE name = 'DMResultSetStatistics_Idx1')
	DROP INDEX DMResultSetStatistics.DMResultSetStatistics_Idx1
GO
SET QUOTED_IDENTIFIER  OFF
GO
GO

declare @retCode integer		-- Now do Error Check

set @retCode = @@error
if (@retCode <> 0)
BEGIN
	set @retCode = @@error;
	print 'RETVAL: 10 View File [DMResultSetStatistics]'
END
GO



--  ------------  Generated from [../../../Source/CommServer/DM2Db/CSView/DMResultItemView.view] ---------- 

SET QUOTED_IDENTIFIER  OFF
SET ANSI_NULLS  ON
print "... Creating View: DMResultItemView"
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[DMResultItemView]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[DMResultItemView]
GO

delete from GXDBVersions where name = 'DMResultItemView' and type=4
insert into GXDBVersions  (type, name, revision, aliasname, SafeRevision) VALUES (4,'DMResultItemView', '1.6', 'DMResultItemView', '')
GO
SET QUOTED_IDENTIFIER  ON
GO
CREATE view DMResultItemView
as
SELECT ISNULL(AP.IsEmailAppType, 0) AS IsEmailAppType,
	(CONVERT(XML, RI.ResultSet)).value('(/DM2ContentIndexing_GResultItem/@fileName)[1]', 'nvarchar(max)') AS AttachmentFileName,
	RS.ModifiedTime AS ItemModifiedTime,
	CI.ContainerID AS ContainerID,
	RS.ResultSetID, RS.AppType, RS.OriginalFullPath, RS.DestinationPath, CI.CreateTime,
	RS.RestoreStatus, RS.RestoreTime, RS.Attribute, RS.documentID, RS.ClientID, RS.ERMStatus,
	RI.ResultSet, '' AS CommentsBy, ISNULL((SELECT TOP 1 LEN(ISNULL(COMMENT, '')) FROM DMUserComment UC WHERE CI.ContainerID = UC.ContainerID AND CI.ResultSetID = UC.ResultSetID AND LEN(ISNULL(COMMENT, '')) > 0 AND (attribute & 4) = 0), 0) as CommentLength,
	(CI.Attribute & 8) AS LegallyHeldFlag, dbo.fn_dm2_GetResultItemTags(RS.ResultSetID, 1, 1, '', CI.ContainerID) AS Tags,
	'' as Containers
FROM DMContainerItem CI
JOIN DMResultSet RS ON CI.ResultSetID = RS.ResultSetID
JOIN DMResultSetInfo RI ON RS.ResultSetID =  RI.ResultSetID
LEFT JOIN DMUIAppTypeMap AP ON RS.AppType = AP.AppTypeId
GO
SET QUOTED_IDENTIFIER  OFF
GO
GO

declare @retCode integer		-- Now do Error Check

set @retCode = @@error
if (@retCode <> 0)
BEGIN
	set @retCode = @@error;
	print 'RETVAL: 10 View File [DMResultItemView]'
END
GO

