

--  ------------  Generated from [../../../Source/CommServer/DM2Db/Upgrade/DMContainerItem.upg] ---------- 

--USE commserv
SET QUOTED_IDENTIFIER OFF
--$Id: DMContainerItem.upg,v 1.14.2.1 2017/02/10 19:17:51 chandru Exp $
BEGIN--Need a Batch to return out of for concatenated scripts
DECLARE @oldRev CHAR(20)    		
  	DECLARE @oldVal CHAR(256)			
  	DECLARE @retCode   INTEGER			
  	DECLARE @sqlError  INTEGER			
  	SET     @retCode = 0              	
  	DECLARE @sqlString nvarchar(MAX)	
      DECLARE @parentID INTEGER				
      DECLARE @tName nvarchar(128)			
      DECLARE @colID INTEGER					
      DECLARE @constId INTEGER				
      DECLARE @cName   nvarchar(128)			
  	DECLARE @oldConstraintName   nvarchar(128)	
  	DECLARE @newConstraintName   nvarchar(128)	
  	DECLARE @keyname   nvarchar(128)		
      DECLARE @dbName   nvarchar(128)			
  	DECLARE @IsNullableAttr VARCHAR(100)	
  	DECLARE @DefaultValAttr NVARCHAR(MAX)	
  	DECLARE @DataType     NVARCHAR(	256)	
  	SET ROWCOUNT 0							
  	SET NOCOUNT ON--Declare/Initialize @oldRev, @oldVal, @retCode
SELECT @dbName = DB_NAME()													
  SELECT @oldRev = (SELECT revision FROM GXDBVersions WHERE name = 'DMContainerItem')	
  IF (@oldRev IS NULL)														
  BEGIN                 														
      SET @oldRev = '0.0'														
  END																			
  IF NOT EXISTS (SELECT * FROM sysobjects										
  WHERE type = 'U'															
  AND name = 'DMContainerItem')														
  BEGIN																		
  	SET @oldRev = '0.0'														
  	DELETE FROM GXDBVersions WHERE name = 'DMContainerItem'							
  END																			
  IF (@oldRev = '1.10')       												
  BEGIN																		
      PRINT 'RETVAL: 0   Table [' +'DMContainerItem' +'] does NOT require upgrade.'	
  END																			
  else																		
  BEGIN																		
      PRINT 'Upgrading Table [' +'DMContainerItem' +'].'							
  END--	 Get @oldRev, compare to '1.10'. Chk for work to do.


IF NOT EXISTS (select * from sysobjects where id = object_id(N'[dbo].[DMContainerItem]') and OBJECTPROPERTY(id, N'IsTable') = 1)
BEGIN



--  ------------  Generated from [../../../Source/CommServer/DM2Db/Tbl/DMContainerItem.tbl] ---------- 





-- ALLOW_COMMENTS_BELOW_HERE:

-- ----------------------------------------------------------------------

--

--           Copyright (c) 1998  CommVault Systems, Inc.

--                  All rights reserved.

--

--

--        This is unpublished proprietary source code of CommVault

--        Systems, Inc. The copyright notice above does not evidence

--        any actual or intended publication of such source code.

-- ----------------------------------------------------------------------*/

-- rcsid="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/DM2Db/Tbl/DMContainerItem.tbl,v $ $Id: DMContainerItem.tbl,v 1.10 2015/07/13 19:31:16 chandru Exp $";

print '... Creating Table: DMContainerItem'

exec ('



DECLARE @tblRetCode integer

Set NOCOUNT ON





create table DMContainerItem (

	ContainerID 	char(36)	NOT NULL,

	QueryID 			char(36)	NOT NULL,

	ResultSetID 	char(36)	NOT NULL,

	CreateTime 		datetime,

	Attribute 		int	NOT NULL,

	UserGUID		char(36)	NOT NULL,

	ID  int IDENTITY(1,1)NOT NULL





CONSTRAINT [PK_DMContainerItem] PRIMARY KEY(

[ID]

)WITH (IGNORE_DUP_KEY = OFF) ON [PRIMARY]

constraint FK_DMContainerItem_DMResultSet foreign key (ResultSetID) references DMResultSet(ResultSetID)

 

 )  ON [PRIMARY]





CREATE UNIQUE NONCLUSTERED INDEX IDX_UQ_DMContainerItem_ContainerID_ResultSetID ON DMContainerItem([ContainerID], [ResultSetID])



INCLUDE ([CreateTime],[Attribute])



CREATE NONCLUSTERED INDEX IDX_DMContainerItem_ResultSetID ON DMContainerItem([ResultSetID])



insert into GXDBVersions values(1, ''DMContainerItem'',  ''1.10'', ''DMContainerItem'', '''')

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 10 Table [GXDBVersions]''

END

-------------------------------------------------------------




')
END
---============================================================================================================
--drop the index created by view on DMContainerItem table, before pruning this table
--
		IF EXISTS (SELECT * FROM sysindexes WHERE name = 'DMResultSetStatistics_Idx1') 

		BEGIN

			DROP INDEX DMResultSetStatistics.DMResultSetStatistics_Idx1

		END

---============================================================================================================
---============================================================================================================
--delete entries whose resultsetId doesnt exists in DMResultSet
--
		IF EXISTS (SELECT TOP 1 CI.ResultSetID

		FROM DMContainerItem AS CI WITH (NOLOCK)	

			LEFT OUTER JOIN

			DMResultSet AS RS WITH (NOLOCK)

			ON CI.ResultSetId = RS.ResultSetId 

			WHERE RS.ResultSetID IS NULL)

		BEGIN

			EXEC('DELETE CI

				FROM DMContainerItem AS CI 		

					LEFT OUTER JOIN

					DMResultSet AS RS WITH (NOLOCK)

					ON CI.ResultSetId = RS.ResultSetId 

					WHERE RS.ResultSetID IS NULL')

		END

---============================================================================================================
---============================================================================================================
----- Script to remove duplicate entries for (containerId, resultsetId)
		IF EXISTS (SELECT  TOP (1) containerid, resultsetid FROM DMContainerItem WITH (NOLOCK) 

		GROUP BY containerid, resultsetid HAVING COUNT(*) > 1 )

		BEGIN

--ONE LINE QUERY without batch deletion . Alternative for all below code.
--
--DELETE DM2Cont FROM
--(SELECT  ROW_NUMBER() OVER (PARTITION BY containerid, resultsetid ORDER BY containerid, resultsetid) cnt
--FROM DMContainerItem)
--DM2Cont WHERE DM2Cont.Cnt > 1
			IF OBJECT_ID('tempdb.dbo.#tmpContainerItemsPrune') IS NOT NULL

				DROP TABLE #tmpContainerItemsPrune

--Create temp tbl for holding ResultSetId
			CREATE TABLE #tmpContainerItemsPrune

			(

				ContainerId VARCHAR(36),

				ResultSetId VARCHAR(36)

			) ;		

			CREATE NONCLUSTERED INDEX IDX_tmpContainerItemsPrune_1 ON #tmpContainerItemsPrune([ContainerID]);

			CREATE NONCLUSTERED INDEX IDX_tmpContainerItemsPrune_2 ON #tmpContainerItemsPrune([ResultSetId])

DECLARE @batchCnt INT = 10000--lets set to 10000
			INSERT INTO #tmpContainerItemsPrune (containerid, resultsetid)

			SELECT  TOP (@batchCnt) containerid, resultsetid FROM DMContainerItem WITH (NOLOCK) 

			GROUP BY containerid, resultsetid HAVING COUNT(*) > 1 

			WHILE EXISTS ( SELECT 1 FROM #tmpContainerItemsPrune)

			BEGIN

				EXEC('DELETE DM2Cont FROM

					(SELECT  ROW_NUMBER() OVER (PARTITION BY a.containerid, a.resultsetid ORDER BY a.containerid, a.resultsetid) cnt

						FROM DMContainerItem a 

						WHERE a.ContainerID IN ( SELECT DISTINCT b.ContainerID FROM #tmpContainerItemsPrune b) AND

							 a.ResultSetID IN ( SELECT DISTINCT b.ResultSetID FROM #tmpContainerItemsPrune b)

						) 

				DM2Cont

				WHERE DM2Cont.Cnt > 1')

--delete temp table
				DELETE #tmpContainerItemsPrune			

--now insert next batch
				INSERT INTO #tmpContainerItemsPrune

				SELECT  TOP (@batchCnt) containerid, resultsetid FROM DMContainerItem WITH (NOLOCK) 

				GROUP BY containerid, resultsetid HAVING COUNT(*) > 1

			END

			IF OBJECT_ID('tempdb.dbo.#tmpContainerItemsPrune') IS NOT NULL

				DROP TABLE #tmpContainerItemsPrune

		END

---============================================================================================================
EXECUTE @retCode = cvsp_drop_fkeys @fromTable = 'DMContainerItem', @fromColumn = 'FK_DMContainer_DMContainerItem', @toTable = 'DMContainerItem'

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'DMContainerItem' AND xType = 'U')				
  	IF NOT EXISTS (SELECT  name FROM sys.foreign_keys WHERE parent_object_id = @parentID AND name = 'FK_DMContainerItem_DMResultSet')	
  	BEGIN																								
  		SET @sqlString = 'ALTER TABLE [' + 'DMContainerItem' +']' + 'ADD CONSTRAINT [' + 'FK_DMContainerItem_DMResultSet' +'] FOREIGN KEY (' + 'ResultSetId' + ') REFERENCES ['+ 'DMResultSet' +'] (' + 'ResultSetId' + ') ON DELETE CASCADE'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'DMContainerItem' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'IDX_DMContainerItem_1')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'DMContainerItem' +'].[' + 'IDX_DMContainerItem_1' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'DMContainerItem' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'IDX_DMContainerItem_ContainerID_ResultSetID')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'DMContainerItem' +'].[' + 'IDX_DMContainerItem_ContainerID_ResultSetID' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

--below index will get created in DMResultSet.upg as well on conditional basis, any change made to this constraint must be made in dMresultSet.up as well.
SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'DMContainerItem' AND xType = 'U')								
      IF NOT EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'IDX_UQ_DMContainerItem_ContainerID_ResultSetID')					
      BEGIN																								
  		SET @sqlString = 'CREATE UNIQUE INDEX [' + 'IDX_UQ_DMContainerItem_ContainerID_ResultSetID' +']' + 'ON [' + 'DMContainerItem' +']  (' + 'ContainerID, ResultSetID' + ') INCLUDE ('+ 'CreateTime, Attribute' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'DMContainerItem' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'IDX_ContainerItem_ContainerId')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'DMContainerItem' +'].[' + 'IDX_ContainerItem_ContainerId' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'DMContainerItem' AND COLUMN_NAME="UserGUID")			
  	BEGIN																														
  		SET @sqlString = "ALTER TABLE " + 'DMContainerItem' + " ADD "+"UserGUID" + " "+"char(36)"			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'DMContainerItem' AND xType = 'U')								
      IF NOT EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'IDX_DMContainerItem_ResultSetID')					
      BEGIN																								
  		SET @sqlString = 'CREATE INDEX [' + 'IDX_DMContainerItem_ResultSetID' +']' + 'ON [' + 'DMContainerItem' +']  (' + 'ResultSetID' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'DMContainerItem' AND COLUMN_NAME="ID")           
      BEGIN                                                                                                                       
          SET @sqlString = "ALTER TABLE " + 'DMContainerItem' + " ADD "+"ID" + " "+"int" + " IDENTITY("+"1" + ","+"1"    
              + ") NOT NULL "                                                                                                         
          IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END                                                                                                         
      END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'DMContainerItem' AND xType = 'U')								
  	SELECT @keyname = (SELECT  name FROM sysobjects WHERE parent_obj = @parentID AND xtype = 'PK')		
  	IF (@keyname IS NULL OR @keyname != 'PK_DMContainerItem')														
  	BEGIN																								
  		IF (@keyname IS NOT NULL)																		
  		BEGIN																							
  			EXECUTE @retCode = cvsp_drop_pk 'DMContainerItem'													
  		END																								
  		SET @sqlString = 'ALTER TABLE [' + 'DMContainerItem' +']' + 'ADD CONSTRAINT [' + 'PK_DMContainerItem' +'] PRIMARY KEY (' + 'ID' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

IF (@retCode < 10)													
  	BEGIN																
  		IF NOT EXISTS (SELECT * FROM GXDBVersions WHERE name = 'DMContainerItem')			
  			insert into GXDBVersions VALUES(1, 'DMContainerItem', '0.0', 'DMContainerItem', '')	
  			UPDATE GXDBVersions SET revision = '1.10' WHERE name = 'DMContainerItem'		
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), @retCode) + 'Table [' + 'DMContainerItem' + '] upgraded successfully to '			+ ' revision [' + '1.10' + '].'										
  	END																	
  	else																
  		PRINT 'RETVAL: ' + CONVERT(CHAR(5), @retCode) + ' TABLE ' + 'DMContainerItem' + ' Upgrade Completed with Errors.'  
  	RETURN			   -- No more upgrade for this TABLE!-- Update cvTable & return

END

GO
IF @@error <> 0 RETURN
GO
